$(document).ready(function() {
  var initUniform = function() {
    if ($.isFunction($.fn.uniform)){
      $("select, input:checkbox, input:radio, input:file", cnt).uniform();
      $('select').parents('.selector').each(function (){ $(this).addClass($('select', this).attr('class'))} );
    }
  }

  if ($("#viewport").length == 0) {
    $(".viewport:first").attr('id', 'viewport');
  }

  $.layout = new $.ui.layout(".layout");
  $.layout._init();
  $.layout.refresh = function(){
    this._resize();
    this._equalize_cells();

    if( typeof after_resize == 'function' ) { 
      after_resize( cnt );
    } 
  }

  $('select').parents('.selector').each(function (){ $(this).addClass($('select', this).attr('class'))} );
  $('button:not(.disabled)').removeAttr("disabled");
  $('button.disabled').attr("disabled","disabled");
  initUniform();

  var cnt = $('body');

  $( 'table.fill:has(tbody):visible', cnt ).each( function(){
    var $table = $( this )
    var $tbody = $( 'tbody', $table )
    var $row = $('<tr><td>&nbsp;</td></tr>')
    if ( $('tr:has(td):last', $table).length > 0 ){
      $row = $('tr:has(td):last', $table).clone()
      $( 'td', $row ).html('&nbsp;')
      var remove_attrs = ['id', 'onclick', 'onchange', 'class']
      var attrs = $.map($row.get(0).attributes, function (a) { return a.nodeName; });
      for (var i=0; i<attrs.length; i++){
        if ( attrs[i].indexOf('data') == 0 || $.inArray(attrs[i], remove_attrs) != -1 )
          $row.removeAttr( attrs[i] )     
      }
    } else {
      var colspan = 0
      $('tr:first', $table).children().filter(':visible').each( function(){ colspan = colspan + parseInt($(this).attr('colSpan')) })
      if (colspan != 0)
        $('td:first', $row).attr('colSpan', colspan)
    }

    var limit = 50
    var $parent = $table.parents('div:first')
    while ( ( $parent.outerHeight() * 2 /* *2 is temp fix */ - $table.outerHeight() ) >= -1 && limit > 0 ){
      $tbody.append( $row.clone() )
      limit = limit - 1
    }
  });

  var page = 1;
  var loading = false;

  var nearBottomOfPage = function() {
    return $(".content").scrollTop() > $(".feedback").height() - 600;
  }

  $(".content").scroll(function(){
    if (nearBottomOfPage() && !loading) {
      page++;
      loading = true;
      locale = $("#locale").val();
      $.get('/globalize/translations/feedback?locale=' + locale + '&page=' + page, function(data) {
          $(".feedback").append(data);
          initUniform();
          loading = false;
      });
    }
  });

  $(".feedback").delegate(".send_feedback", "click", function() {
    var self = $(this);
    var current_globalize_translation_id = self.attr("globalize-translation-id");

    if (cookie('phrase_suggestion_for_' + current_globalize_translation_id) != null) {
      alert('Your feedback is currently under review. Thanks.');
      return;
    } else {
      if (current_globalize_translation_id == null || current_globalize_translation_id == '') {
        alert('No phrase was selected.');
        return;
      }

      var url = "/globalize/translations/send_feedback/" + current_globalize_translation_id;
      var body = self.parents("tr").find(".suggestion").val();
      var current_selected_suggestion = self.parents("tr").find("select.suggestion_options").val();
      var data = null;

      if (body != null && body != '') {
        data = { body: body };
      } else if (current_selected_suggestion != null && current_selected_suggestion != '') {
        data = { globalize_translation_suggestion_id: current_selected_suggestion }
      }

      if (data == null) {
        alert('Please, select a suggestion or send a new one.');
        return;
      }

      $.ajax({
        type: 'POST',
        url: url,
        data: data,
        success: function(data, textStatus, xmlHttpRequest){
          cookie('phrase_suggestion_for_' + current_globalize_translation_id, current_globalize_translation_id);
          self.parents("td").html("Sent");
        },
        error: function(xht){
          alert($.parseJSON(xht.response).errors.join(", "));
        }
      });
    }
  });
});