class GlobalizeTranslationSuggestionsController < ApplicationController
  before_filter :find_suggestion, :except => :feedback

  def send_feedback
    if @translation_suggestion
      @translation_suggestion.increment!(:votes)
    else
      suggestion = @globalize_translation.globalize_translation_suggestions.build(:value => params[:body])

      if !suggestion.save
        render :json => { :errors => suggestion.errors.full_messages }, :format => "json", :status => :unprocessable_entity
        return
      end
    end

    render :nothing => true, :status => :ok
  end

  def feedback
    @current_locale = params[:locale].blank? ? I18n.default_locale : params[:locale]

    @translations = GlobalizeTranslation.includes(:globalize_translation_suggestions).
                                         where(:locale => @current_locale).
                                         order(:key)

    unless params[:query].blank?
      @translations = @translations.where("value like ?", "%#{params[:query]}%")
    end

    @translations = @translations.offset(params[:page].to_i * 20).limit(40).all

    if request.xhr?
      render :partial => "globalize_translation", :collection => @translations
    else
      render :layout => 'globalize_feedback'
    end
  end

  private
  def find_suggestion
    @globalize_translation = GlobalizeTranslation.find(params[:globalize_translation_id])

    if @globalize_translation
      if !params[:body].blank?
        @translation_suggestion = @globalize_translation.globalize_translation_suggestions.where(:value => params[:body]).first
      elsif !params[:globalize_translation_suggestion_id].blank?
        @translation_suggestion = @globalize_translation.globalize_translation_suggestions.find(params[:globalize_translation_suggestion_id])
      end
    end
  end
end